;;;
;;; Un compilateur d'expressions binaires.
;;;
(load "expressions.scm")
(load "machine.scm")

;;;
;;; La fonction auxiliaire "compile_aux" compile l'expression en n'utilisant
;;;  que des registres de rang suprieur ou gal  "n". L'excution du
;;;  programme engendr place le rsultat de l'expression dans le registre
;;;  "Rn".
;;;    compile_aux: expression, nat -> program
;;;
(define (compile_aux expression nreg)
    (if (identifier? expression)
	(mkprog (mkinstr 'ld (mkregister nreg) expression))
	(prog-concate  (compile_aux (expr-left expression) nreg)
		       (compile_aux (expr-right expression) (1+ nreg))
		      (mkprog (mkinstr
			       (operator->operation (expr-operator expression))
			       (mkregister nreg) (mkregister (1+ nreg)))))))

;;;
;;; Le compilateur produit un programme dont l'excution place la valeur
;;;  de l'expression dans le registre R0:
;;;   compile: expression -> program
;;;
(define (compile expression)
  (compile_aux expression 0))
