;;;
;;; L'valuateur impratif de programmes machine:
;;;

(load "machine.scm")

;;; Les instructions de la machine
(define-macro (ld registre valeur)
  `(set! ,registre ,valeur))

(define-macro (define-operation symbol operation)
  `(define-macro (,symbol cible source)
     (list 'set! cible (list ,operation cible source))))
(define-operation add +)
(define-operation sub -)
(define-operation div /)
(define-operation mult *)

;;; Evaluateur impratif de programme
;;;   mexec: program, environment -> number
(define-macro (mexec program environnement)
  
  ;; Construit une liste qui dfinit tout les registres utiliss
  ;; Rajoute le programme et 'R0  la fin de cette liste
  (define (mexec-reg prog dejavu)
    (if (prog-vide? prog)
	(append program '(R0))
	(let ((registre (instr-cible (prog-tete prog))))
	  (if (memq registre dejavu)
	      (mexec-reg (prog-reste prog) dejavu)
	      (cons (list 'define registre '())
		    (mexec-reg (prog-reste prog) (cons registre dejavu)))))))

  ;; Construit une liste qui affecte les identificateurs
  ;; de l'environnement  leur valeur.
  ;; Rajoute la liste renvoy par mexec-reg  la fin de cette liste.
  (define (mexec-env env dejavu)
    (if (null? env)
	(mexec-reg program '())
	(if (memq (caar env) dejavu)
	    (mexec-env (cdr env) dejavu)
	    (cons (list 'define (caar env) (cdar env))
		  (mexec-env (cdr env) (cons (caar env) dejavu))))))

  (cons 'begin (mexec-env environnement '())))
