;;;
;;; Le type de donnes des expressions binaires.
;;;

;;; Les accesseurs
(define expr-left car)
(define expr-right caddr)
(define expr-operator cadr)

;;; Valeur d'un identificateur dans l'environnement
(define (getenv identifier environnement)
  (cdr (assq identifier environnement)))

;;; Les prdicats
(define (identifier? expression)
  (not (pair? expression)))

;;; Les oprations d'une expressions
(define operator->fonction eval)

;;; Si la fonction eval n'existe pas
;;; (c'est peut-tre le cas pour les anciennes versions de guile)
;;(define (operator->fonction operation)
;;  (cdr (assq operation `((+ . ,+)(- . ,-)(* . ,*)(/ . ,/))))))

;;; Evaluation d'une expression :
;;; evalexpr expression,environnement -> nombre
(define (evalexpr expression environnement)
  (if (identifier? expression)
      (getenv expression environnement)
      ((operator->fonction (expr-operator expression))
       (evalexpr (expr-left expression) environnement)
       (evalexpr (expr-right expression) environnement))))
