;;;
;;; Une machine  5 instructions et infinit de registres.
;;;

;;; Type de donnes "register":
;;;  mkregister: nat -> register      ; constructeur de registre.
(define (mkregister n)
  (string->symbol (string-append "R" (number->string n))))

;;; Type de donnes "programme":
;; Les accesseurs
(define prog-tete car)	; premire instruction d'un programme
(define prog-reste cdr)	; Les instructions suivantes
;; Les prdicats
(define prog-vide? null?)
;; Les constructeurs
(define mkprog list)	; mkprog instr_1, ... instr_n -> prog
;; Concatenation de programmes
(define prog-concate append)

;;; Les instructions de la machine  la compilation
(define (operator->operation operation)
  (case operation
    ('+ 'add)
    ('- 'sub)
    ('/ 'div)
    ('* 'mult)))

;;; Type de donnes "instruction":
;; Les constructeurs
(define mkinstr list)	; mkinstr operation,cible,source -> instr
;; Les accesseurs
(define instr-operation car)
(define instr-cible cadr)
(define instr-source caddr)

;;; Valeur d'un identificateur dans l'environnement
(define (getenv identifier environnement)
  (cdr (assq identifier environnement)))

;;; Les instructions de la machine
(define (operation->fonction operation)
  (case operation
    ('add +)
    ('sub -)
    ('div /)
    ('mult *)))

;;; Evaluation d'une instruction
;;; renvoie une association  ajouter  l'environnement
(define (eval-instruction instruction environnement)
  (let ((operation (instr-operation instruction))
	(cible (instr-cible instruction))
	(source (instr-source instruction)))
    (cons cible
	   (if (eq? operation 'ld)
	       (getenv source environnement)
	       ((operation->fonction operation)
		(getenv cible environnement)
		(getenv source environnement))))))

;;; Evaluateur de programmes machine:
;;;  evalprog: program, environment -> environment
(define (evalprog program environnement)
  (if (prog-vide? program)
      environnement
      (evalprog (prog-reste program)
		(cons
		 (eval-instruction (prog-tete program) environnement)
		 environnement))))
