;;; Projet

(define (evalprog program environnement)
  (let ((liste-operation '((add . +)(sub . -)(mult . *)(div . /))))
    (define (eval-identifier identifier)
      (cdr (assq identifier environnement)))
    (define (eval-expression instruction)
      (let ((operation (car instruction)))
	(case operation
	  ('ld (let ((register (cadr instruction))
		     (identifier (caddr instruction)))
		 (cons register (eval-identifier identifier))))
	  (else
	   (let ((target (cadr instruction))
		 (source (caddr instruction)))
	     (cons target
		   ((eval (cdr (assq operation liste-operation)))
		    (eval-identifier target)
		    (eval-identifier source))))))))
    (if (null? program)
	environnement
	(evalprog (cdr program)
		  (cons (eval-expression (car program)) environnement)))))


(evalprog '(
	    (ld R0 A)
	    (ld R1 B)
	    (sub R1 R0)
	    )
	  '(
	    (A . 1)
	    (B . 3)
	    ))

(define (evalexpr expression environnement)
  (if (pair? expression)
      ((eval (cadr expression)) (evalexpr (car expression) environnement)
				(evalexpr (caddr expression) environnement))
      (cdr (assq expression environnement))))

(evalexpr '((A * C) + (B / C)) '((A . 1)(B . 2)(C . 3)))

(define (compile expression)
  (compile_aux expression 0))

(define (mkregister n)
  (string->symbol (string-append "R" (number->string n))))

(define (compile_aux expression nreg)
  (cond ((pair? expression)
	 (append (append (compile_aux (car expression) nreg)
			 (compile_aux (caddr expression) (1+ nreg)))
		 (list (list 'add (mkregister nreg) (mkregister (1+ nreg)))))
	 ) ;;; remplacer add...
	(else
	 (list (list 'ld (mkregister nreg) expression))
	 )))

(compile '((A + B)*(C - D)))

(define (exec program environnement)
  (define add +)
  (define sub -)
  (define mult *)
  (define div /)
  (define ld define)
  (eval (mexec program environnement)))
  ;;  (eval (mexec program environnement)))

(define (mexec program environnement)
  (define (f environnement)
    (if (null? environnement)
	program
	(cons (list 'define (caar environnement) (cdar environnement))
	      (f (cdr environnement)))))
  (cons 'let (cons '() (f environnement))))

(exec '((ld R0 A)
        (ld R1 B)
        (add R0 R1))
       '((A . 12) (B . 24) (C . 36)))

