;;; Projet

 (define-macro (mexec program environnement)
   `(if (null? (cdr ,environnement))
	(define-registre ,program)
	 (begin (define (caar ,environnement) (cdar ,environnement))
		(mexec ,program (cdr ,environnement)))))

(macroexpand '(mexec prog env))

(define-macro (mcons . forms)
  (if (null? forms)
      ()
      `(cons ,(car forms) (mcons . ,(cdr forms)))))

(macroexpand-1 '(mcons 1 2 3 4 5))
(mcons 1 2 3 4 5)


 (define-macro (mac arg)
   `(if (not (null? (cdr ,arg)))
	     (cons (car ,arg)
		   (mac (cdr ,arg)))
	     ()))
 (define l '(1 2 3 4 5))
 (macroexpand '(mac l))
 (mac l)
 (mac '(1 2))

(define (evalexpr expression environnement)
  (if (pair? expression)
      ((eval (cadr expression)) (evalexpr (car expression) environnement)
				(evalexpr (caddr expression) environnement))
      (cdr (assq expression environnement))))

(evalexpr '((a + b) * (c - d))
		    '((a . 12) (b . -11) (c . 17) (d . 16)))


(define (evalprog program environnement)

  (define (operation->fonction operation)
  (case operation
    ('add +)
    ('sub -)
    ('div /)
    ('mult *)
    (else (error "Opration invalide :" op))))

  (define (eval-identifier identifier)
    (cdr (assq identifier environnement)))

  (define (eval-expression instruction)
  (let ((operation (car instruction))
	(cible (cadr instruction))
	(source (caddr instruction)))
    (cons cible
     (if (eq? operation 'ld)
	 (eval-identifier source)
	 ((operation->fonction operation) (eval-identifier cible)
					(eval-identifier source))))))
  (if (null? program)
      environnement
      (evalprog (cdr program)
		(cons (eval-expression (car program)) environnement))))

(evalprog '((ld R0 A)
	    (ld R1 B)
	    (sub R1 R0))
	  '((A . 1)
	    (B . 3)))


(define (mkregister n)
  (string->symbol (string-append "R" (number->string n))))

(define (compile expression)
  (compile_aux expression 0))

(define (compile_aux expression nreg)
  (let ((liste-operation '((+ . add)(- . sub)(* . mult)(/ . div))))
    (if (pair? expression)
	   (append (append (compile_aux (car expression) nreg)
			   (compile_aux (caddr expression) (1+ nreg)))
		   (list (list (cdr (assq (cadr expression) liste-operation))
			       (mkregister nreg) (mkregister (1+ nreg)))))
	   (list (list 'ld (mkregister nreg) expression)))))

(compile '((A + B) * (C - D)))


(define-macro (define-operation symbol operation)
  `(define-macro (,symbol a b)
     (list 'set! a (list ,operation a b))))
(define-operation add +)
(define-operation sub -)
(define-operation div /)
(define-operation mult *)

(define-macro (ld registre valeur)
  `(set! ,registre ,valeur))

(define-macro (mexec program environnement)
  (define (mexec-aux env)
    (if (null? env)
	(append (reg program) program '(R0))
	(cons (list 'define (caar env) (cdar env))
	      (mexec-aux (cdr env)))))
  (cons 'let (cons '() (mexec-aux environnement))))

(macroexpand '(mexec ((ld R0 A)
		       (ld R1 B)
		       (add R0 R1))
		     ((A . 12) (B . 24) (C . 36))))

(mexec ((ld R0 A)
        (ld R1 B)
        (add R0 R1))
       ((A . 12) (B . 24) (C . 36)))

(define (reg program)
  (map (lambda (registre)
	 (list 'define registre '()))
       (reverse (simple (map cadr program) '()))))

(define (simple liste resultat)
  (if (null? liste)
      resultat
      (if (memq (car liste) resultat)
	  (simple (cdr liste) resultat)
	  (simple (cdr liste) (cons (car liste) resultat)))))

(reverse (simple '(a b c d a b e) '()))

(reg '((ld R0 A)
        (ld R1 B)
        (add R0 R1)))
