;;;
;;; Test des valuateurs et du compilateur:
;;;
(load "compiler.scm")
(load "exec.scm")

(define R0 ())

(or (= 1 (evalexpr '((a + b) * (c - d))
		   '((a . 12) (b . -11) (c . 17) (d . 16))))
    (error "evalexpr"))

(or (equal? 36
	    (cdr (assq 'R0 (evalprog '((ld R0 A)
				       (ld R1 B)
				       (add R0 R1)
				       (ld R1 C))
				     '((A . 12) (B . 24) (C . 36))))))
    (error "evalprog"))

(or (equal? '((ld R0 A)        ; A
	      (ld R1 B)        ; B
	      (add R0 R1)      ; (A + B)
	      (ld R1 C)        ; C
	      (ld R2 D)        ; D
	      (sub R1 R2)      ; (C - D)
	      (mult R0 R1))    ; ((A + B) * (C - D))
	    (compile '((A + B) * (C - D))))
    (error "compile"))

(or (= 36 (let ()
	    (mexec ((ld R0 A)
		    (ld R1 B)
		    (add R0 R1)
		    (ld R1 C))
		   ((A . 12) (B . 24) (C . 36)))))
    (error "mexec"))
